package com.allpayx.atsmpservice.mapper.slaver;

import com.allpayx.atsmpservice.param.RequestParam.RecoredConfirmInfoRequest;
import com.allpayx.atsmpservice.param.ResponseParam.RecoredConfirmInfoResponse;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.springframework.stereotype.Component;

import java.util.List;

@Component
public interface AtsTxMapper {

    @Update("update VOUCHER_LOG set process_status =#{process_status},voucher_status=#{voucher_status} where create_time>=#{receive_start_date} and " +
            "create_time <  #{receive_end_date} and ecp_code=#{ecp_code} and currency =#{currency}")
    void updateRecoredConfirmStatus(RecoredConfirmInfoRequest recoredConfirmInfo);

    @Select({"<script>",
            "select * from VOUCHER_LOG",
            "WHERE 1=1" ,
            "<if test='receive_start_date!=null  &amp;&amp; receive_start_date.length()>0'>",
            "AND create_time >= #{receive_start_date}",
            "</if>",
            "<if test='receive_end_date!=null  &amp;&amp; receive_end_date.length()>0'>",
            "AND create_time &lt;=  #{receive_end_date}",
            "</if>",
            "<if test='entry_start_date!=null  &amp;&amp; entry_start_date.length()>0'>",
            "AND DONE_TIME >= #{entry_start_date}",
            "</if>",
            "<if test='entry_end_date!=null   &amp;&amp; entry_end_date.length()>0'>",
            "AND DONE_TIME &lt;=  #{entry_end_date}",
            "</if>",
            "<if test='ecp_code!=null &amp;&amp; ecp_code.length()>0'>",
            "AND ECP_CODE = #{ecp_code}",
            "</if>",
            "<if test='currency!=null &amp;&amp; currency.length()>0'>",
            "AND CURRENCY = #{currency}",
            "</if>",
            "<if test='process_status!=null &amp;&amp; process_status.length()>0'>",
            "AND PROCESS_STATUS = #{process_status}",
            "</if>",
            "<if test='voucher_id!=null &amp;&amp; voucher_id.length()>0'>",
            "AND voucher_id = #{voucher_id}",
            "</if>",
            "<if test='user_id!=null &amp;&amp; user_id.length()>0'>",
            "AND user_id = #{user_id}",
            "</if> order by create_time desc",
            "</script>"})
    List<RecoredConfirmInfoResponse> selectRecordConfirmInfo(RecoredConfirmInfoRequest recoredConfirmInfo);
    @Insert("Insert into VOUCHER_LOG(voucher_id,voucher_type,process_status,voucher_status,currency,amount,done_time,user_id,ecp_code,create_time) " +
            "VALUES(#{voucher_id},#{voucher_type},#{process_status},#{voucher_status},#{currency},#{amount},#{done_time},#{user_id},#{ecp_code},#{create_time})")
    void insertRecoredImportReport(RecoredConfirmInfoResponse recoredConfirmInfoResponse);
}
